<?php

/**
 * @version 4.0.17
 * @author Txt42
 * @copyright Copyright (c) 2024 EdSDK (https://txt42.ai/). All rights reserved.
 * @license GNU General Public License version 3 or later
 */

defined('_JEXEC') or die(); // No direct access

class Txt42Controller extends JControllerLegacy
{
    /**
     * flmngr Method to display a file manager.
     *
     * @return json string or null
     */
    public function flmngr()
    {
        $user = JFactory::getUser();
        if ($user->authorise('core.edit', 'com_txt42') == true) {
            require JPATH_SITE .
                '/components/com_txt42/libraries/file-manager/flmngr.php';
        }
        die();
    }

    /**
     *  Method for setting API key and access token from Txt42 in the article
     */
    public function setApiKey()
    {
        $user = JFactory::getUser();
        if ($user->authorise('core.edit', 'com_txt42') == true) {
            // Load the current component params.
            $params = JComponentHelper::getParams('com_txt42');
            // Set new value of param(s)
            $params->set('api_key', $_POST['txt42ApiKey'] . ':' . $_POST['txt42Token']);

            // Save the parameters
            $componentid = JComponentHelper::getComponent('com_txt42')->id;
            $table = JTable::getInstance('extension');
            $table->load($componentid);
            $table->bind(['params' => $params->toString()]);

            // check for error
            if (!$table->check()) {
                http_response_code(500);
                echo $table->getError();
                die();
            }
            // Save to database
            if (!$table->store()) {
                http_response_code(500);
                echo $table->getError();
                die();
            }
        }

        http_response_code(200);
        die();
    }

}
